function varargout = Set(varargin)
% SET MATLAB code for Set.fig
%      SET, by itself, creates a new SET or raises the existing
%      singleton*.
%
%      H = SET returns the handle to a new SET or the handle to
%      the existing singleton*.
%
%      SET('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SET.M with the given input arguments.
%
%      SET('Property','Value',...) creates a new SET or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Set_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Set_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Set

% Last Modified by GUIDE v2.5 21-Sep-2013 14:41:35

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Set_OpeningFcn, ...
                   'gui_OutputFcn',  @Set_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Set is made visible.
function Set_OpeningFcn(hObject, eventdata, handles, varargin)
global Def Str o ;
Def = cell(1,2);
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Set (see VARARGIN)
set(handles.E1, 'string', char.empty(1,0));
set(handles.E2, 'string', char.empty(1,0));
set(handles.pb1, 'enable', 'on');
set(handles.pb2, 'enable', 'on');
str = {'Please input the number of lines and rows of the trays in the image correctly.', '', 'This helps the calculation when some of the images are  indistinct.'};
set(handles.text3, 'string', str);
o = 1;
Str = cell(1,1);
Str{1} = 'Waiting for calculating...';
o = o+1;
set(handles.L1, 'string', Str, 'value', 1);
% Choose default command line output for Set
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Set wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = Set_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pb1.
function pb1_Callback(hObject, eventdata, handles)
global fName pName filenum Def Str o;
if isempty(get(handles.E1, 'string')) || isempty(get(handles.E2, 'string'))
    sel = questdlg('Please set the parameters correctly.', 'Attention', 'OK', 'OK');
    switch sel
        case 'Yes'
            return;
    end
else
    Str{o} = 'Calculating now! Please WAIT.....This takes less than 3 minutes.';
    o = o+1;
    Str{o} = '';
    o = o+1;
    set(handles.L1, 'string', Str);
    set(handles.pb2, 'enable', 'off');
    set(handles.pb1, 'enable', 'off');
    pause(0.2);
    box = zeros(1,1); % record the number of the error images
    L = length(fName);
    P = struct('line', [], 'row', [], 'numl', 0, 'numr', 0);
    Pback = P;
    S = ones(Def{1},Def{2},L);  %need to match the number of the trays in one image
    order = 1;
    for i = 1:L
        str = [pName fName{i}];
        Image = imread(str);
        G = im2double(rgb2gray(Image));
        G1 = round((edge(G, 'sobel', 'horizontal')+edge(G, 'sobel', 'vertical'))/2);
        [P.line P.row  P.numl P.numr] = findedge(G1, G1);
    %     testline(P, G, G1);
        try  % anti-error system~~~~P
            if P.numl < Def{1} || P.numr < Def{2} % to avoid when P.numl<Def{1} the matlab do not recognize the error
                S(:, :, i-i) = 0;
            end
            S(:, :, i) = Integral(P, G);
            if P.numl == Def{1} && P.numr == Def{2}  %store the edge
                Pback = P;
            end
        catch err  %assuming that there should be one image correctly before the bad one.
            Str{o} = sprintf('The %s is indistinct or has indistinct edges, the program used fuzzy computing.', fName{i});
            o = o+1;
            set(handles.L1, 'string', Str);
            pause(0.2);
            if isempty(Pback.line)
                box(order) = i;
                order = order+1;
            else
                try %try again
                    S(:, :, i) = Integral(Pback, G);
                catch err
                    Str{o} = sprintf('A critical error happened and the program stop. Maybe the wrong images or the input parameters unsuitable with the images.');
                    o = o+1;
                    set(handles.L1, 'string', Str);
                    pause(0.2);
                    set(handles.pb2, 'enable', 'on');
                    return;
                end
            end
        end
    end

%if the error images are too many, the program will stop calculate.
    if length(box) == filenum && box ~=0
        Str{o} = sprintf('A critical error happened and the program stop. Maybe the wrong images or the input parameters unsuitable with the images.');
        o = o+1;
        set(handles.L1, 'string', Str);
        pause(0.2);
        return;
    end
    if length(box) > 0.5*filenum
        Str{o} = sprintf('The program stop calculating due to over 50 percent indistinct images.');
        o = o+1;
        set(handles.L1, 'string', Str);
        pause(0.2);
        set(handles.pb2, 'enable', 'on');
        return;
    elseif length(box) >= 0.3*filenum
        Str{o} = sprintf('The results maybe inaccuracy due to over 30 percent indistinct images.');
        o = o+1;
        set(handles.L1, 'string', Str);
        pause(0.2);
    else
        Str{o} = '';
        o = o+1;
        Str{o} = sprintf('Succeed!!!');
        o = o+1;
        set(handles.L1, 'string', Str);
        pause(0.2);
    end

    if box(1) ~= 0
        for i = 1:length(box)
            S(:, :, i) = Integral(Pback, G);
        end
    end

    Ssize = size(S);
    if L == 1
        Ssize(3) = 1;
    end
% change the position of dimensions
    Sf = zeros(Ssize(2), Ssize(3), Ssize(1));
    for k = 1:Ssize(1)
        for i = 1:Ssize(2)
            for j = 1:Ssize(3)
                Sf(i, j, k) = S(k, i, j);
            end
        end
    end

%draw each tray
figure;
Sfsize = size(Sf);
set(gcf, 'Position', [50 50 1000 600]);
k = 1;
for i = 1:Sfsize(3) 
    for j = 1:Sfsize(1)
        subplot(3, 3, k);
        k = k+1;
        plot(1:filenum, Sf(j, :, i));
        xlabel('                          sequence number of images');
        ylabel('fluorescence a.u.');
        title(sprintf('Position: %d %d', i, j));
        if k == 10 && ~(i == Sfsize(3) && j == Sfsize(1))
            figure;
            set(gcf, 'Position', [50 50 1000 600]);
            k = 1;
        end
    end
end

% draw each line
k = 1;
Sm = zeros(1, Ssize(3), Ssize(1));
for i = 1:Sfsize(3)
    Sm(:, :, i) = mean(Sf(:, :, i));
end
figure;
set(gcf, 'position', [100, 50 , 500, 600]);
for i = 1:Sfsize(3)
    subplot(3, 1, k);
    plot(1:filenum, Sm(1, :, i));
    xlabel('                          sequence number of images');
    ylabel('average fluorescence a.u.');
    title(sprintf('Position: line%d', i));
    k = k+1;
    if k == 4 && i ~= Sfsize(3)
        figure;
        set(gcf, 'position', [100, 50 , 500, 600]);
        k = 1;
    end
    set(handles.pb2, 'enable', 'on');
end
end
% hObject    handle to pb1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



function E1_Callback(hObject, eventdata, handles)
global Def;
Def{1} = str2double(get(handles.E1, 'string'));
% hObject    handle to E1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of E1 as text
%        str2double(get(hObject,'String')) returns contents of E1 as a double


% --- Executes during object creation, after setting all properties.
function E1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to E1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function E2_Callback(hObject, eventdata, handles)
global Def;
Def{2} = str2double(get(handles.E2, 'string'));
% hObject    handle to E2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of E2 as text
%        str2double(get(hObject,'String')) returns contents of E2 as a double


% --- Executes during object creation, after setting all properties.
function E2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to E2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in L1.
function L1_Callback(hObject, eventdata, handles)
% hObject    handle to L1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns L1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from L1


% --- Executes during object creation, after setting all properties.
function L1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to L1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pb2.
function pb2_Callback(hObject, eventdata, handles)
set(Set, 'visible', 'off');
% hObject    handle to pb2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
