clear all;

% read the images
[Def] = inputdlg({'Number of lines', 'Number of rows'}, 'Input the lines & rows', 1, {'3', '4'}, 'on');
[Name pName ~] = uigetfile('*.jpg', 'Load files');
M = dir(pName);
L = length(M);
filenum = 0;
fName = cell(1,1);
box = zeros(1,1); % record the number of the error images
for i = 1:L
    if ~isempty(strfind(M(i).name, '.jpg'))
        filenum = filenum+1;
        fName{filenum} = M(i).name;
    end
end
L = length(fName);
P = struct('line', [], 'row', [], 'numl', 0, 'numr', 0);
Pback = P;
S = ones(str2double(Def{1}),str2double(Def{2}),L);  %need to match the number of the trays in one image
order = 1;
for i = 1:L
    str = [pName fName{i}];
    Image = imread(str);
    G = im2double(rgb2gray(Image));
    G1 = round((edge(G, 'sobel', 'horizontal')+edge(G, 'sobel', 'vertical'))/2);
    [P.line P.row  P.numl P.numr] = findedge(G1, G1);
%     testline(P, G, G1);
    try  % anti-error system~~~~P
        if P.numl < str2double(Def{1}) || P.numr < str2double(Def{2}) % to avoid when P.numl<Def{1} the matlab do not recognize the error
            S(:, :, i-i) = 0;
        end
        S(:, :, i) = Integral(P, G);
        if P.numl == str2double(Def{1}) && P.numr == str2double(Def{2})  %store the edge
            Pback = P;
        end
    catch err  %assuming that there should be one image correctly before the bad one.
        fprintf(2, 'The %s is too indistinct to detect, the program used fuzzy computing.\n', fName{i});
        if isempty(Pback.line)
            box(order) = i;
            order = order+1;
        else
            try %try again
%                 testline(Pback, G, G1);
                S(1:str2double(Def{1}), 1:str2double(Def{2}), i) = Integral(Pback, G);
            catch err
                fprintf(2, '\nA critical error happened and the program stop. Maybe the wrong images or the input parameters unsuitable with the images.\n');
                return;
            end
        end
    end
end

%if the error images are too many, the program will stop calculate.
if length(box) == filenum
    fprintf(2, '\nA critical error happened and the program stop. Maybe the wrong images or the input parameters unsuitable with the images.\n');
    return;
end
if length(box) > 0.5*filenum
    fprintf(2, '\nThe program stop calculating due to over 50 percent indistinct images.\n');
    return;
elseif length(box) >= 0.3*filenum
    fprintf(2, '\nThe results maybe inaccuracy due to over 30 percent indistinct images.\n');
else
    fprintf(1, '\nSucceed!\n');
end

if box(1) ~= 0
    for i = 1:length(box)
        S(:, :, i) = Integral(Pback, G);
    end
end

Ssize = size(S);
if L == 1
    Ssize(3) = 1;
end
% change the position of dimensions
Sf = zeros(Ssize(2), Ssize(3), Ssize(1));
for k = 1:Ssize(1)
    for i = 1:Ssize(2)
        for j = 1:Ssize(3)
            Sf(i, j, k) = S(k, i, j);
        end
    end
end

%draw each tray
figure;
Sfsize = size(Sf);
set(gcf, 'Position', [50 50 1000 min(160*(ceil(Sfsize(3)*Sfsize(1)/3)), 600)]);
k = 1;
for i = 1:Sfsize(3) 
    for j = 1:Sfsize(1)
        subplot(3, 3, k);
        k = k+1;
        plot(0:5:(filenum-1)*5, Sf(j, :, i));
        xlabel('                time');
        ylabel('fluorescence a.u.');
        title(sprintf('Position: %d %d', i, j));
        if k == 10 && ~(i == Sfsize(3) && j == Sfsize(1))
            figure;
            set(gcf, 'Position', [50 50 1000 600]);
            k = 1;
        end
    end
end

% draw each line
k = 1;
Sm = zeros(1, Ssize(3), Ssize(1));
for i = 1:Sfsize(3)
    Sm(:, :, i) = mean(Sf(:, :, i));
end
figure;
set(gcf, 'position', [100, 50 , 500, 600]);
for i = 1:Sfsize(3)
    subplot(3, 1, k);
    plot(0:5:(filenum-1)*5, Sm(1, :, i));
    xlabel('                time');
    ylabel('average fluorescence a.u.');
    title(sprintf('Position: line%d', i));
    k = k+1;
    if k == 4 && i ~= Sfsize(3)
        figure;
        set(gcf, 'position', [100, 50 , 500, 600]);
        k = 1;
    end
end

Save(Sf, fName, filenum, Sfsize);
